import { BindableProvider } from './bindable-provider.js';
import { AsyncFactory } from './binder.js';
import { InjectableId, Injector } from './injector.js';
import { State } from './state.js';
/**
 * @inheritDoc
 * This specialization invokes it's configured Factory asynchronously and waits until it can provide the result.
 */
export declare class AsyncFactoryBasedProvider<T> extends BindableProvider<T, AsyncFactory<T>> {
    constructor(injector: Injector, id: InjectableId<T>, maker: AsyncFactory<T>);
    /**
     * @inheritDoc
     * This specialization invokes it's configured Factory and provides the result (or invokes the error handler if necessary).
     */
    provideAsState(): State<T>;
}
